# file BuildStrategyBasic.py
import cffi
ffibuilder = cffi.FFI()

with open('../PythonAlgorithms.h') as f:
    # read plugin.h and pass it to embedding_api(), manually
    # removing the '#' directives and the CFFI_DLLEXPORT
    data = ''.join([line for line in f if not line.startswith('#')])
    data = data.replace('CFFI_DLLEXPORT', '')
    ffibuilder.embedding_api(data)

ffibuilder.set_source("StrategyBasic", r'''
    #include "../PythonAlgorithms.h"
''')

ffibuilder.embedding_init_code("""
    from StrategyBasic import ffi

    @ffi.def_extern()
    def runStrategyBasic(server):
        accountResult = ""
        server.init()
        #server.getAccountInfo(accountResult)
        print("account info: %d" % (accountResult))
        print("finished strategy")
""")

ffibuilder.compile(target="libStrategyBasic.*", verbose=True)
